﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace eCommerce.Services.Model
{
    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.Data.Entity.Core.Objects;
    using System.Linq;
    
    public partial class DbModelEntities : DbContext
    {
        public DbModelEntities()
            : base("name=DbModelEntities")
        {
        }
    
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            throw new UnintentionalCodeFirstException();
        }
    
        public virtual DbSet<Accounting> Accountings { get; set; }
        public virtual DbSet<AccountingOperation> AccountingOperations { get; set; }
        public virtual DbSet<Bank> Banks { get; set; }
        public virtual DbSet<BankInterest> BankInterests { get; set; }
        public virtual DbSet<BankPromotion> BankPromotions { get; set; }
        public virtual DbSet<Banner> Banners { get; set; }
        public virtual DbSet<Brand> Brands { get; set; }
        public virtual DbSet<BusinessUnit> BusinessUnits { get; set; }
        public virtual DbSet<Category> Categories { get; set; }
        public virtual DbSet<CategoryPromotion> CategoryPromotions { get; set; }
        public virtual DbSet<Check> Checks { get; set; }
        public virtual DbSet<City> Cities { get; set; }
        public virtual DbSet<Color> Colors { get; set; }
        public virtual DbSet<Configuration> Configurations { get; set; }
        public virtual DbSet<Contact> Contacts { get; set; }
        public virtual DbSet<Coupon> Coupons { get; set; }
        public virtual DbSet<Currency> Currencies { get; set; }
        public virtual DbSet<Customer> Customers { get; set; }
        public virtual DbSet<CustomerAddress> CustomerAddresses { get; set; }
        public virtual DbSet<CustomerExternalLogin> CustomerExternalLogins { get; set; }
        public virtual DbSet<DeliveryMethod> DeliveryMethods { get; set; }
        public virtual DbSet<DeliveryOrder> DeliveryOrders { get; set; }
        public virtual DbSet<DeliveryOrderDetail> DeliveryOrderDetails { get; set; }
        public virtual DbSet<DeliveryStatu> DeliveryStatus { get; set; }
        public virtual DbSet<DeliverySupplier> DeliverySuppliers { get; set; }
        public virtual DbSet<DeliverySuppliersDetail> DeliverySuppliersDetails { get; set; }
        public virtual DbSet<DeliveryType> DeliveryTypes { get; set; }
        public virtual DbSet<Deposit> Deposits { get; set; }
        public virtual DbSet<Exchange> Exchanges { get; set; }
        public virtual DbSet<ExchangeDetail> ExchangeDetails { get; set; }
        public virtual DbSet<ExcludedProduct> ExcludedProducts { get; set; }
        public virtual DbSet<Faq> Faqs { get; set; }
        public virtual DbSet<Image> Images { get; set; }
        public virtual DbSet<Institutional> Institutionals { get; set; }
        public virtual DbSet<Lookbook> Lookbooks { get; set; }
        public virtual DbSet<LookbookGroup> LookbookGroups { get; set; }
        public virtual DbSet<LookbookProduct> LookbookProducts { get; set; }
        public virtual DbSet<MPAccount> MPAccounts { get; set; }
        public virtual DbSet<MPAccountRelationship> MPAccountRelationships { get; set; }
        public virtual DbSet<News> News { get; set; }
        public virtual DbSet<Newsletter> Newsletters { get; set; }
        public virtual DbSet<NewsletterProduct> NewsletterProducts { get; set; }
        public virtual DbSet<NewsSuscriber> NewsSuscribers { get; set; }
        public virtual DbSet<OcaShipment> OcaShipments { get; set; }
        public virtual DbSet<OcaShipmentOrigin> OcaShipmentOrigins { get; set; }
        public virtual DbSet<Order> Orders { get; set; }
        public virtual DbSet<OrderDetail> OrderDetails { get; set; }
        public virtual DbSet<OrderPayment> OrderPayments { get; set; }
        public virtual DbSet<OrderStatu> OrderStatus { get; set; }
        public virtual DbSet<Parameter> Parameters { get; set; }
        public virtual DbSet<PaymentMethod> PaymentMethods { get; set; }
        public virtual DbSet<PaymentStatu> PaymentStatus { get; set; }
        public virtual DbSet<PERMISSION> PERMISSIONS { get; set; }
        public virtual DbSet<PhotoProduct> PhotoProducts { get; set; }
        public virtual DbSet<Product> Products { get; set; }
        public virtual DbSet<ProductPromotion> ProductPromotions { get; set; }
        public virtual DbSet<ProductRelationship> ProductRelationships { get; set; }
        public virtual DbSet<ProductSku> ProductSkus { get; set; }
        public virtual DbSet<Proform> Proforms { get; set; }
        public virtual DbSet<Promotion> Promotions { get; set; }
        public virtual DbSet<Promotion_PaymentMethods> Promotion_PaymentMethods { get; set; }
        public virtual DbSet<PromotionalText> PromotionalTexts { get; set; }
        public virtual DbSet<Province> Provinces { get; set; }
        public virtual DbSet<Purchase> Purchases { get; set; }
        public virtual DbSet<PurchaseDetail> PurchaseDetails { get; set; }
        public virtual DbSet<PurchasePayment> PurchasePayments { get; set; }
        public virtual DbSet<Refund> Refunds { get; set; }
        public virtual DbSet<RefundDetail> RefundDetails { get; set; }
        public virtual DbSet<Rma> Rmas { get; set; }
        public virtual DbSet<RmaItem> RmaItems { get; set; }
        public virtual DbSet<RmaItemStatu> RmaItemStatus { get; set; }
        public virtual DbSet<RmaStatu> RmaStatus { get; set; }
        public virtual DbSet<ROLE> ROLES { get; set; }
        public virtual DbSet<SalerDeposit> SalerDeposits { get; set; }
        public virtual DbSet<Size> Sizes { get; set; }
        public virtual DbSet<Stock> Stocks { get; set; }
        public virtual DbSet<StockMovement> StockMovements { get; set; }
        public virtual DbSet<Store> Stores { get; set; }
        public virtual DbSet<Story> Stories { get; set; }
        public virtual DbSet<StoryImage> StoryImages { get; set; }
        public virtual DbSet<Supplier> Suppliers { get; set; }
        public virtual DbSet<SupplierProduct> SupplierProducts { get; set; }
        public virtual DbSet<Tag> Tags { get; set; }
        public virtual DbSet<Transaction> Transactions { get; set; }
        public virtual DbSet<TransactionCategory> TransactionCategories { get; set; }
        public virtual DbSet<TransactionDetail> TransactionDetails { get; set; }
        public virtual DbSet<TransactionType> TransactionTypes { get; set; }
        public virtual DbSet<USER> USERS { get; set; }
        public virtual DbSet<WishlistItem> WishlistItems { get; set; }
        public virtual DbSet<ZClose> ZCloses { get; set; }
    
        public virtual ObjectResult<GetPurchaseLabels_Result> GetPurchaseLabels()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetPurchaseLabels_Result>("GetPurchaseLabels");
        }
    
        public virtual int InsertProductsFromSabana()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("InsertProductsFromSabana");
        }
    
        public virtual int InsertProductsFromSabana1()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("InsertProductsFromSabana1");
        }
    
        public virtual int UpdateStockVirtual(Nullable<int> productId, Nullable<int> sizeId, Nullable<int> colorId, Nullable<int> stockVirtual)
        {
            var productIdParameter = productId.HasValue ?
                new ObjectParameter("ProductId", productId) :
                new ObjectParameter("ProductId", typeof(int));
    
            var sizeIdParameter = sizeId.HasValue ?
                new ObjectParameter("SizeId", sizeId) :
                new ObjectParameter("SizeId", typeof(int));
    
            var colorIdParameter = colorId.HasValue ?
                new ObjectParameter("ColorId", colorId) :
                new ObjectParameter("ColorId", typeof(int));
    
            var stockVirtualParameter = stockVirtual.HasValue ?
                new ObjectParameter("StockVirtual", stockVirtual) :
                new ObjectParameter("StockVirtual", typeof(int));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("UpdateStockVirtual", productIdParameter, sizeIdParameter, colorIdParameter, stockVirtualParameter);
        }
    }
}
